function [Rleft,Rright,n] = denseButterflyPB(queryGabor,allGabor,allGaborCellSize,pb,theta,r)
% Inputs:
% queryGabor
% allGabor
% allGaborCellSize
% pb
% theta
% r
%
% Outputs:
% Rleft
% Rright
% n

% Parameters:
minPBval = 0.07;%0.011; % Minimum PB value to work with
allOrient = [0:pi/8:pi-pi/8];
Ngrid = [16 12];%[62 46];

imageSize = [size(pb,1) size(pb,2)];
N = size(allGabor,4);

% Get PB locations:
n = find(pb>minPBval);

Rleft = zeros(N,length(n),'uint16');
Rright = zeros(N,length(n),'uint16');
for i = 1:length(n)
  display(sprintf('%d out of %d',i,length(n)));
  
  [y,x] = ind2sub(imageSize,n(i));
  
  j = find(ismember(allOrient,theta(n(i))));
  
  % Get butterfly wings:
  [wLeft,wRight] = getButterflyWings(imageSize,x,y,allOrient(j),r);
  
  % Query left lobe:
  wLeft = single(gridResponse(wLeft,allGaborCellSize));
  d = queryFlickrWeighted(queryGabor,allGabor,Ngrid,wLeft);
  [v,nLeft] = sort(d);
  
  % Query right lobe:
  wRight = single(gridResponse(wRight,allGaborCellSize));
  d = queryFlickrWeighted(queryGabor,allGabor,Ngrid,wRight);
  [v,nRight] = sort(d);
  
  % Store ranks:
  Rleft(nLeft,i) = 1:N;
  Rright(nRight,i) = 1:N;
end

return;

% Parameters:
minPBval = 0.07;%0.011; % Minimum PB value to work with
allOrient = [0:pi/8:pi-pi/8];
Ngrid = [16 12];%[62 46];

imageSize = [size(pb,1) size(pb,2)];
N = size(allGabor,4);

% Get PB locations:
n = find(pb>minPBval);

Rleft = zeros(N,length(n),length(allOrient),'uint16');
Rright = zeros(N,length(n),length(allOrient),'uint16');
for j = 1:length(allOrient)
  for i = 1:length(n)
    display(sprintf('%d: %d out of %d',j,i,length(n)));

    [y,x] = ind2sub(imageSize,n(i));
    
    % Get butterfly wings:
    [wLeft,wRight] = getButterflyWings(imageSize,x,y,allOrient(j),r);

    % Query left lobe:
    wLeft = single(gridResponse(wLeft,allGaborCellSize));
    d = queryFlickrWeighted(queryGabor,allGabor,Ngrid,wLeft);
    [v,nLeft] = sort(d);

    % Query right lobe:
    wRight = single(gridResponse(wRight,allGaborCellSize));
    d = queryFlickrWeighted(queryGabor,allGabor,Ngrid,wRight);
    [v,nRight] = sort(d);

    % Store ranks:
    Rleft(nLeft,i,j) = 1:N;
    Rright(nRight,i,j) = 1:N;
  end
end
