// distMatL1.cpp
// Created: 7/4/2007
// Updated: 7/4/2007
// To compile, run at the command prompt:
// mex distMatL1.cpp

#include <math.h>
#include "mex.h"

double min(double a,double b) {
  if(a<=b) return a;
  return b;
}

// Inputs: P1,P2
// Outputs: D
void mexFunction(int nlhs,mxArray *plhs[],int nrhs,const mxArray *prhs[]) {
//   if(nrhs != 3) {
//     mexErrMsgTxt("Error: 3 args. needed.");
//     return;
//   }

//   mxClassID class_id = mxGetClassID(prhs[0]);

  double *p1 = mxGetPr(prhs[0]);
  double *p2 = mxGetPr(prhs[1]);
  double trunc;
  if(nrhs==2) trunc = 1000000;
  else trunc = *mxGetPr(prhs[2]);

  int n1 = mxGetN(prhs[0]);
  int n2 = mxGetN(prhs[1]);
  int dim = mxGetM(prhs[0]);

  if(dim != mxGetM(prhs[1])) {
    mexErrMsgTxt("Error: Inputs must have same number of rows.");
    return;
  }

  // Allocate outputs:
  plhs[0] = mxCreateDoubleMatrix(n1,n2,mxREAL);
  double *D = mxGetPr(plhs[0]);

  int ii = 0;
  double tot;
  for(int c2=0; c2<n2; c2++) {
    for(int c1=0; c1<n1; c1++) {
      tot = 0;
      for(int dd=0; dd<dim; dd++) {
	tot += fabs(min(p1[dd+c1*dim]-p2[dd+c2*dim],trunc));
      }
      D[ii++] = tot;
    }
  }
}
