function [wLeft,wRight] = getButterflyWings(imageSize,x,y,thetaB,r)
% Inputs:
% imageSize
% x
% y
% thetaB
% r
%
% Outputs:
% wLeft
% wRight

sp = 10; %16;
c = [x y];
[xx,yy] = meshgrid(1:imageSize(2),1:imageSize(1));
w = exp(-0.5*((xx-c(1)).^2+(yy-c(2)).^2)/r^2);

sgn = 2*double(thetaB<=pi/2)-1;

% Left wing:
wLeft = double(sgn*yy >= sgn*(tan(thetaB)*(xx-c(1)+sp*cos(thetaB-pi/2))+c(2)-sp*sin(thetaB-pi/2))).*w;

% Right wing:
wRight = double(sgn*yy <= sgn*(tan(thetaB)*(xx-c(1)-sp*cos(thetaB-pi/2))+c(2)+sp*sin(thetaB-pi/2))).*w;

return;

% Debug butterfly wings:
figure;
for thetaB = [0:pi/8:pi-pi/8]
  [wLeft,wRight] = getButterflyWings(imageSize,x,y,thetaB,r);
  clf;
  imshow([wLeft wRight]);
  hold on;
  plot(x,y,'r+');
  plot(x+imageSize(2),y,'r+');
  pause;
end
