function [allImg,imgNdx] = getImageStack(varargin)
% $$$ function allImg = getImageStack(folder,imageSize)

if nargin == 2
  folder = varargin{1};
  imageSize = varargin{2};
  
  files = dir(fullfile(folder,'*.jpg'));
  allImg = zeros(imageSize(1),imageSize(2),3,length(files),'uint8');
  for i = 1:length(files)
    i
    timg = imresize(imread(fullfile(folder,files(i).name)),imageSize);
    if size(timg,3) < 3
      timg = repmat(timg,[1 1 3]);
    end
    allImg(:,:,:,i) = timg;
  end
  imgNdx = [];
else
  DB = varargin{1};
  HOMEIMAGES = varargin{2};
  imgNdx = varargin{3};
  imageSize = varargin{4};
  Kstack = varargin{5};

  allImg = zeros(imageSize(1),imageSize(2),3,Kstack+1,'uint8');
  i = 1;
  ii = 1;
  n = zeros(1,Kstack);
  while i <= Kstack
    i
    timg = imread(fullfile(HOMEIMAGES,DB(imgNdx(ii)).annotation.folder,DB(imgNdx(ii)).annotation.filename));
% $$$     timg = LMimread(DB,imgNdx(ii),HOMEIMAGES);
    timg = imresize(timg,imageSize);
    if size(timg,3) < 3
      timg = repmat(timg,[1 1 3]);
    end
    if sum(sum(sum(abs(timg-allImg(:,:,:,i))))) >= 0.01
      allImg(:,:,:,i+1) = timg;
      n(i) = imgNdx(ii);
      i = i+1;
    end
    ii = ii+1;
  end
  imgNdx = n;
end
