function d = queryFlickrWeighted(queryGabor,allGabor,Ngrid,w)
% queryGabor
% allGabor
% Ngrid - [Nx Ny]
% w
%
% Outputs:
% d

% Get spatial extents of grid cells:
Sx = round(linspace(0,size(allGabor,2),Ngrid(1)+1));
Sy = round(linspace(0,size(allGabor,1),Ngrid(2)+1));

% Clip weights:
w = max(min(w,1),0);
if size(w,3)==1
  w = repmat(w,[1 1 size(queryGabor,3)]);
end

wMax = max(w,[],3);

% Crop non-zero grid cells, for efficiency:
for i = 1:length(Sx)-1
  if sum(sum(wMax(:,Sx(i)+1:Sx(i+1))))/size(wMax,1)/(Sx(i+1)-Sx(i)) >= 0.01
    break;
  end
end
Sx = Sx(i:end);
for i = length(Sx)-1:-1:1
  if sum(sum(wMax(:,Sx(i)+1:Sx(i+1))))/size(wMax,1)/(Sx(i+1)-Sx(i)) >= 0.01
    break;
  end
end
Sx = Sx(1:i+1);

for i = 1:length(Sy)-1
  if sum(sum(wMax(Sy(i)+1:Sy(i+1),:)))/size(wMax,2)/(Sy(i+1)-Sy(i)) >= 0.01
    break;
  end
end
Sy = Sy(i:end);
for i = length(Sy)-1:-1:1
  if sum(sum(wMax(Sy(i)+1:Sy(i+1),:)))/size(wMax,2)/(Sy(i+1)-Sy(i)) >= 0.01
    break;
  end
end
Sy = Sy(1:i+1);

% Compute distance between feature vectors:
% $$$ tic;
stackNdx = int32(1); % This needs to be modified...
d = compareGaborMex(queryGabor,allGabor,w,int32(Sx),int32(Sy),stackNdx);
% $$$ toc

% Plot grid cell spatial extents:
showCellGrid = 0;
if showCellGrid
  imshow(gridResponse(mean(double(img)/255,3),allGaborCellSize));
  hold on;
  for xx = 1:length(Sx)-1
    for yy = 1:length(Sy)-1
      plot([Sx(xx)+1 Sx(xx+1) Sx(xx+1) Sx(xx)+1 Sx(xx)+1],[Sy(yy)+1 Sy(yy)+1 Sy(yy+1) Sy(yy+1) Sy(yy)+1],'y');
    end
  end
end
