function labels = rankGraphCut(unaryCosts,X,Y,PB,theta,alpha,beta,outlierThresh)
% Inputs:
% unaryCosts
% X
% Y
% PB
% theta
% alpha
% beta
% outlierThresh

BIGNUM = 10000;%max(Td(:));

[h,w] = size(PB);
N = size(unaryCosts,3);

% DataCost:
if ~isempty(outlierThresh)
  DataCost = -1*ones(h,w,N+1,'single');
  j = sub2ind([h w],Y(:),X(:));
  for i = 1:N
    dd = zeros(h,w);
    uu = unaryCosts(:,:,i);
    dd(j) = uu(:);
    DataCost(:,:,i) = dd;
  end
  dd = zeros(h,w);
  dd(j) = outlierThresh;
  DataCost(:,:,end) = dd;
else
  DataCost = -1*ones(h,w,N,'single');
  j = sub2ind([h w],Y(:),X(:));
  for i = 1:N
    dd = zeros(h,w);
    uu = unaryCosts(:,:,i);
    dd(j) = uu(:);
    DataCost(:,:,i) = dd;
  end
end

DataCost = permute(DataCost,[3 2 1]);

% Smoothness Cost:
if ~isempty(outlierThresh)
  SmoothnessCostH = BIGNUM*ones(N+1,w-1,h,'single');
else
  SmoothnessCostH = BIGNUM*ones(N,w-1,h,'single');
end
for xx = 1:w-1
  for yy = 1:h
    if theta(yy,xx+1) < pi/2
      maxPB = max(0,PB(yy,xx+1)-PB(yy,xx));
    elseif theta(yy,xx) >= pi/2
      maxPB = max(0,PB(yy,xx)-PB(yy,xx+1));
    else
      maxPB = 0;
    end
    SmoothnessCostH(:,xx,yy) = -alpha+beta*maxPB;

% $$$     if theta(Y(yy,xx),X(yy,xx+1)) < pi/2
% $$$       maxPB = max(0,PB(Y(yy,xx),X(yy,xx+1))-PB(Y(yy,xx),X(yy,xx)));
% $$$     elseif theta(Y(yy,xx),X(yy,xx)) >= pi/2
% $$$       maxPB = max(0,PB(Y(yy,xx),X(yy,xx))-PB(Y(yy,xx),X(yy,xx+1)));
% $$$     else
% $$$       maxPB = 0;
% $$$     end
% $$$     SmoothnessCostH(:,xx,yy) = -alpha+beta*maxPB;
  end
end

if ~isempty(outlierThresh)
  SmoothnessCostV = BIGNUM*ones(N+1,w,h-1,'single');
else
  SmoothnessCostV = BIGNUM*ones(N,w,h-1,'single');
end
for xx = 1:w
  for yy = 1:h-1
    maxPB = max(0,PB(yy,xx)-PB(yy+1,xx));
% $$$     maxPB = max(0,PB(Y(yy,xx),X(yy,xx))-PB(Y(yy+1,xx),X(yy,xx)));
    SmoothnessCostV(:,xx,yy) = -alpha+beta*maxPB;
  end
end

if ~isempty(outlierThresh)
  SmoothnessCost = [[N+1 w h]'; SmoothnessCostH(:); SmoothnessCostV(:)];
else
  SmoothnessCost = [[N w h]'; SmoothnessCostH(:); SmoothnessCostV(:)];
end

labels = graphCutsMexDiag(DataCost,SmoothnessCost)'+1;


return;

%%%% OLD CODE BELOW HERE %%%%

% Parameters:
BIGNUM = 10000;%max(Td(:));

[h,w] = size(outlier);
N = 3;

% DataCost
DataCost = single(outlier);
DataCost(:,:,2) = dummy;
DataCost(:,:,3) = (1-single(valid)).*(-BIGNUM*ones(size(valid)));
DataCost = permute(DataCost,[3 2 1]);

% Smoothness Cost:
SmoothnessCostH = BIGNUM*ones(N,w-1,h,'single');
for xx = 1:w-1
  for yy = 1:h
    if (valid(yy,xx)&&~valid(yy,xx+1)) || (valid(yy,xx+1)&&~valid(yy,xx))
      SmoothnessCostH(:,xx,yy) = [0 0 2*BIGNUM]';
    elseif ~valid(yy,xx)&&~valid(yy,xx+1)
      SmoothnessCostH(:,xx,yy) = [0 0 -BIGNUM]';
    else
      if theta(Y(yy,xx),X(yy,xx+1)) < pi/2
        maxPB = max(0,PB(Y(yy,xx),X(yy,xx+1))-PB(Y(yy,xx),X(yy,xx)));
      elseif theta(Y(yy,xx),X(yy,xx)) >= pi/2
        maxPB = max(0,PB(Y(yy,xx),X(yy,xx))-PB(Y(yy,xx),X(yy,xx+1)));
      else
        maxPB = 0;
      end
      SmoothnessCostH(:,xx,yy) = [(-alpha+beta*maxPB)*ones(2,1); BIGNUM];
    end
  end
end

SmoothnessCostV = BIGNUM*ones(N,w,h-1,'single');
for xx = 1:w
  for yy = 1:h-1
    if (valid(yy,xx)&&~valid(yy+1,xx)) || (valid(yy+1,xx)&&~valid(yy,xx))
      SmoothnessCostV(:,xx,yy) = [0 0 2*BIGNUM]';
    elseif ~valid(yy,xx)&&~valid(yy+1,xx)
      SmoothnessCostV(:,xx,yy) = [0 0 -BIGNUM]';
    else
      maxPB = max(0,PB(Y(yy,xx),X(yy,xx))-PB(Y(yy+1,xx),X(yy,xx)));
      SmoothnessCostV(:,xx,yy) = [(-alpha+beta*maxPB)*ones(2,1); BIGNUM];
    end
  end
end

SmoothnessCost = [[N w h]'; SmoothnessCostH(:); SmoothnessCostV(:)];

labels = graphCutsMexDiag(DataCost,SmoothnessCost)'+1;
