function pbStack = ranks2PBstack(Rleft,Rright,Rndx,pb,tieThresh,FLAG)
% Inputs:
% Rleft
% Rright
% Rndx
% pb
% tieThresh
% FLAG - pbstack | corr
%
% Outputs:
% pbStack

if nargin < 5
  tieThresh = [];
end
if nargin < 6
  FLAG = 'pbstack';
end

if prod(size(pb))>2
  imageSize = [size(pb,1) size(pb,2)];
else
  imageSize = pb;
end

switch FLAG
 case 'corr'
  pbStack = ones(imageSize);
 otherwise
  pbStack = zeros(imageSize);
end

% Look at rank correlation score at PB orientation:
for i = 1:length(Rndx)
  % Compute rank correlation:
  r1 = double(Rleft(:,i));
  r2 = double(Rright(:,i));

  if ~isempty(tieThresh)
    % Incorporate ties:
    r1(r1>tieThresh) = tieThresh+1;
    r2(r2>tieThresh) = tieThresh+1;
  end
  
  rho = rankCorrelation(r1,r2);
  
  switch FLAG
   case 'corr'
    pbStack(Rndx(i)) = rho;
   otherwise
    rho = (1-rho)/2;
    
    % Set score:
    pbStack(Rndx(i)) = rho*pb(Rndx(i));
  end
end
