% function gist = runGistIm(Im)
%
% To have similar descriptors as the flickr image database 
% The input image should be 375x500.
% 
%
function gist = runGistIm(Im)


%doresize        = .5;
doresize        = .25;

%imageSize = 128;
orientationsPerScale = [8 8 4];
Nblocks_longer  = 6;
Nblocks_shorter = 4;


% filter(w,h) ... store fft filters for different image sizes
filter(2048,2048).G = [];


doplot = 0;
clear gist;
%gist.im_dir =   im_dir;
%gist.imdd   = imdd;
gist.imdd   = 1;
gist.dim.w  = zeros(length(gist.imdd),1);
gist.dim.h  = zeros(length(gist.imdd),1);
gist.dim.d  = zeros(length(gist.imdd),1);
%gist.D      = single(zeros(sum(orientationsPerScale)*Nblocks_longer*Nblocks_shorter*3,length(gist.imdd),1));
gist.D      = single(zeros(sum(orientationsPerScale)*Nblocks_longer*Nblocks_shorter,length(gist.imdd),1));

i2  = 1;
imo = Im;
imo = mean(imo,3);

if doresize
    %PYR = pyramid15(
    tic;
    im = imresize(imo,doresize,'bilinear');
    %im = imresize(imo,doresize,'nearest','antialiasing',true);
% $$$     mre_printf('Resize %dx%dx%d->%dx%dx%d ..%.2fs ',size(imo),size(im),toc);

    if doplot
        figure(1);clf;  imagesc(imo); axis image; truesize;
        figure(2); clf; imagesc(im); axis image; truesize;
        drawnow;
    end;

else
    im = imo;
end;


[h w d]          = size(im);
gist.dim.w(i2) = w;
gist.dim.h(i2) = h;
gist.dim.d(i2) = d;

if ~isempty(filter(w,h).G)
    G = filter(w,h).G;
else
    tic;
    G = createGaborJosef(orientationsPerScale, w,h);
    filter(w,h).G = G;
% $$$     mre_printf('\n Create filters w%.d x h%.d   ... %.2f \n',w,h,toc);
end;

% compute Gist + store it as singles
if w>h % landscape
    NblocksX = Nblocks_longer;
    NblocksY = Nblocks_shorter;
else % portrait
    NblocksX = Nblocks_shorter;
    NblocksY = Nblocks_longer;
end;

% pre-filter image
tic;
output = prefiltJosef(double(im), 4);

% compute gist
g            = gistGabor_NxNyJosef(output, NblocksX,NblocksY, G);
gist.D(:,i2) = single(g);
% $$$ mre_printf(' Gist .. %.2fs \n',toc);


if 0
    % save
    mre_printf('Saving %s \n',out_gist_name);
    save(out_gist_name,'gist','-mat');

    % waity few seconds and remove lock
    pause(10);
    delete(out_gist_lock);
end;

% show image sizes and aspect ratios
if 0
    figure(1); clf;
    plot(gist.dim.w,gist.dim.h,'.b');
    axis equal;
    aa = unique([gist.dim.w,gist.dim.h],'rows');
    size(aa);
    hold on;
    plot(aa(:,1),aa(:,2),'.r');
    size([gist.dim.w,gist.dim.h]);

    figure(2); clf;
    hist(gist.dim.w,100);
    title('w');

    figure(3); clf;
    hist(gist.dim.h,100);
    title('h');

    figure(4); clf;
    bb=gist.dim.w ./ gist.dim.h;
    hist(bb,100);
    title('w/h');

    % show images of sizes d
end;





